
package net.mcreator.jedandjethrosmod.fluid;

import net.minecraftforge.fluids.ForgeFlowingFluid;
import net.minecraftforge.fluids.FluidAttributes;

import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.LiquidBlock;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.core.particles.ParticleOptions;

import net.mcreator.jedandjethrosmod.init.JedAndJethrosModModItems;
import net.mcreator.jedandjethrosmod.init.JedAndJethrosModModFluids;
import net.mcreator.jedandjethrosmod.init.JedAndJethrosModModBlocks;

public abstract class BioFuelFluid extends ForgeFlowingFluid {
	public static final ForgeFlowingFluid.Properties PROPERTIES = new ForgeFlowingFluid.Properties(() -> JedAndJethrosModModFluids.BIO_FUEL,
			() -> JedAndJethrosModModFluids.FLOWING_BIO_FUEL, FluidAttributes.builder(new ResourceLocation("jed_and_jethros_mod:blocks/biofueltex"),
					new ResourceLocation("jed_and_jethros_mod:blocks/biofueltex"))

	).explosionResistance(100f)

			.tickRate(7)

			.bucket(() -> JedAndJethrosModModItems.BIO_FUEL_BUCKET).block(() -> (LiquidBlock) JedAndJethrosModModBlocks.BIO_FUEL);

	private BioFuelFluid() {
		super(PROPERTIES);
	}

	@Override
	public ParticleOptions getDripParticle() {
		return ParticleTypes.UNDERWATER;
	}

	public static class Source extends BioFuelFluid {
		public Source() {
			super();
			setRegistryName("bio_fuel");
		}

		public int getAmount(FluidState state) {
			return 8;
		}

		public boolean isSource(FluidState state) {
			return true;
		}
	}

	public static class Flowing extends BioFuelFluid {
		public Flowing() {
			super();
			setRegistryName("flowing_bio_fuel");
		}

		protected void createFluidStateDefinition(StateDefinition.Builder<Fluid, FluidState> builder) {
			super.createFluidStateDefinition(builder);
			builder.add(LEVEL);
		}

		public int getAmount(FluidState state) {
			return state.getValue(LEVEL);
		}

		public boolean isSource(FluidState state) {
			return false;
		}
	}
}
